function util_get_shopee_main_website(){
    let url = window.location.href;
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    urlArr = url.split('/');
    if(urlArr.length>0){
        return "https://"+urlArr[0];
    }
    return '';
}

function util_price_format(price = 0){
    if(price){
        price = parseInt(price);
        return (price / 100000).toFixed(2);
    }
    return price;
}

function util_capitalizeFirstLetter(str='') {
  return str.charAt(0).toUpperCase() + str.slice(1);
}

/**
 * 字典数组排序，只针对纯英文、数字或纯中文的排序
 * @param: dictArray 需要排序的字典数组
 * @param: sortKey  需要进行排序的键
 * @param: sortType asc升序(默认)  desc 降序
 **/
function util_dictArraySorting(dictArray,sortKey,sortType="asc"){
    if (sortType == 'asc'){
      dictArray.sort(function (dictA, dictB){
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictA[sortKey] - dictB[sortKey]:dictA[sortKey].localeCompare(dictB[sortKey])
      })
    }
    if (sortType == 'desc'){
      dictArray.sort(function (dictA, dictB){
        return escape(dictA[sortKey]).indexOf("%u") < 0? dictB[sortKey] - dictA[sortKey]:dictB[sortKey].localeCompare(dictA[sortKey])
      })
    }
    return dictArray
}

//搜索页采集、类目
function shangjia_search_caiji(){
    setTimeout(function (){
        var message = {
            action: 'can_list_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=> {
            console.log('can_list_caiji 答复', msg)
            let msgobj = JSON.parse(msg);
            console.log(msgobj['state']);
            if (msgobj['state'] == 0) { //可以自动采集
                add_productListAddToPluginButton();
                console.log('list采集已开启');
                console.log('shangjia_search_caiji');
                let current_url = window.location.href;
                if(current_url) {
                    if (current_url.indexOf('search?keyword') != -1 || current_url.indexOf('-cat') != -1) {
                        let shopee_main_website = util_get_shopee_main_website();
                        var shangjia_infos = [];
                        let i=1;
                        $(".shopee-search-item-result__items .shopee-search-item-result__item").each(function (){
                            let _shangjia_a_link = $(this).find('a').attr('href');
                            console.log('_shangjia_a_link:'+_shangjia_a_link);
                            if(_shangjia_a_link && _shangjia_a_link.indexOf('-i') != -1){
                                let _shangjia_a_link_arr = _shangjia_a_link.split('?');
                                _shangjia_a_link = _shangjia_a_link_arr[0];
                                let _shangjia_id = _shangjia_a_link;
                                let _shangjia_a_link_www = shopee_main_website+_shangjia_a_link;
                                let _shangjia_info = {
                                    '_shangjia_id': _shangjia_id,
                                    '_shangjia_name': '',
                                    '_shangjia_a_link':_shangjia_a_link_www,
                                    '_shangjia_img': '',
                                    '_shangjia_price': '',
                                    '_shangjia_old_price': '',
                                    '_shangjia_review_score': '',
                                    '_shangjia_reivew_num': 0,
                                    '_shangjia_sold':0
                                };
                                //console.log(_shangjia_info);
                                shangjia_infos.push(_shangjia_info);
                                //
                                if(shangjia_infos.length > 50){
                                    var message = {
                                        action: 'shangjia_items_update',
                                        info: '',
                                        shangjia_infos: shangjia_infos
                                    };
                                    send_message_to_popup(message);
                                    shangjia_infos = [];
                                }
                                //
                                console.log('i:'+i);
                                i++;
                            }
                        });
                        //
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        send_message_to_popup(message);
                        //
                        //处理自动化采集
                        //zidong_caiji_next();
                        //
                    }
                }
            }else{
                console.log('list采集已关闭');
            }
        });
    },1000);
}

//卖家列表
function shangjia_maijia_list_caiji(){
    setTimeout(function (){
        var message = {
            action: 'can_list_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=> {
            console.log('can_list_caiji 答复', msg)
            let msgobj = JSON.parse(msg);
            console.log(msgobj['state']);
            if (msgobj['state'] == 0) { //可以自动采集
                console.log('list采集已开启');
                console.log('shangjia_maijia_list_caiji');
                let current_url = window.location.href;
                if(current_url) {
                    if (true) {
                        let shopee_main_website = util_get_shopee_main_website();
                        var shangjia_infos = [];
                        let i=1;
                        $(".shop-search-result-view .shop-search-result-view__item").each(function (){
                            let _shangjia_a_link = $(this).find('a').attr('href');
                            console.log('_shangjia_a_link:'+_shangjia_a_link);
                            if(_shangjia_a_link && _shangjia_a_link.indexOf('-i') != -1){
                                let _shangjia_a_link_arr = _shangjia_a_link.split('?');
                                _shangjia_a_link = _shangjia_a_link_arr[0];
                                let _shangjia_id = _shangjia_a_link;
                                let _shangjia_a_link_www = shopee_main_website+_shangjia_a_link;
                                let _shangjia_info = {
                                    '_shangjia_id': _shangjia_id,
                                    '_shangjia_name': '',
                                    '_shangjia_a_link':_shangjia_a_link_www,
                                    '_shangjia_img': '',
                                    '_shangjia_price': '',
                                    '_shangjia_old_price': '',
                                    '_shangjia_review_score': '',
                                    '_shangjia_reivew_num': 0,
                                    '_shangjia_sold':0
                                };
                                //console.log(_shangjia_info);
                                shangjia_infos.push(_shangjia_info);
                                //
                                if(shangjia_infos.length > 50){
                                    var message = {
                                        action: 'shangjia_items_update',
                                        info: '',
                                        shangjia_infos: shangjia_infos
                                    };
                                    send_message_to_popup(message);
                                    shangjia_infos = [];
                                }
                                //
                                console.log('i:'+i);
                                i++;
                            }
                        });
                        //
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        send_message_to_popup(message);
                        //
                        //处理自动化采集
                        //zidong_caiji_next();
                        //
                    }
                }
            }else{
                console.log('list采集已关闭');
            }
        });
    },1000);
}

//
function zidong_caiji_next(){
    console.log('zidong_caiji_next s');
    let seemore_dom =  $(".autoFitList:eq(0)").siblings("div[role='region']").find('.jJnWizBx ._2U9ov4XG');
    var message = {
        action: 'can_zidong_caiji',
        info: ''
    };
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('zidong_caiji_next 答复',msg)
        let msgobj  = JSON.parse(msg);
        console.log(msgobj['state']);
        if(msgobj['state'] == 0){ //可以自动采集
            console.log('zidong_caiji_next s2');
            //
            seemore_dom.click();
            //
        }
    })
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'fetch'){
            if(performanceResourceItem['name'].indexOf('api/v4/recommend/recommend?bundle=category_landing_page')!=-1 ||
            performanceResourceItem['name'].indexOf('api/v4/search/search_items')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                setTimeout(function (){
                    shangjia_search_caiji();
                },2000);

            }else if(performanceResourceItem['name'].indexOf('api/v4/shop/rcmd_items')!=-1){
                 //console.log(performanceResourceItem['name']);
                console.log('bbbb2'+performanceResourceItem['name']);
                //
                setTimeout(function (){
                    shangjia_maijia_list_caiji();
                },2000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('initialState') !=-1 && scriptContent.indexOf('initialCollections') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}
//
function downloadIamge(imgsrc, name){//下载图片地址和图片名
    let image = new Image();
    // 解决跨域 Canvas 污染问题
    image.setAttribute("crossOrigin", "anonymous");
    image.onload = function() {
        let canvas = document.createElement("canvas");
        canvas.width = image.width;
        canvas.height = image.height;
        let context = canvas.getContext("2d");
        context.drawImage(image, 0, 0, image.width, image.height);
        let url = canvas.toDataURL("image/jpeg"); //得到图片的base64编码数据
        let a = document.createElement("a"); // 生成一个a元素
        let event = new MouseEvent("click"); // 创建一个单击事件
        a.download = name || "photo"; // 设置图片名称
        a.href = url; // 将生成的URL设置为a.href属性
        a.dispatchEvent(event); // 触发a的单击事件
    }
    image.src = imgsrc;
}
//
function get_product_lunbo_imgs(){
    console.log('aaaa');
    //
    let scriptdata = util_getscript_pageData_content($("html").html());
    if(scriptdata) {
        scriptdata = scriptdata.trim();
        let scriptdata_json = JSON.parse(scriptdata);
        console.log('scriptdata_json');
        console.log(scriptdata_json);
        //
        if(scriptdata_json && scriptdata_json['initialState']['item']['items']){
            //
            let items = scriptdata_json['initialState']['item']['items'];
            let items_keys_arr = Object.keys(items);
            let item_key = items_keys_arr[0];
            let _goods_data = items[item_key];
            if(_goods_data['status'] == 1){
                let _shangjia_goodsId = _goods_data['item_id'];
                let images = _goods_data['images'];
                for(let _imgkey=0;_imgkey < images.length; _imgkey++){
                    let _img_name = images[_imgkey];
                    _img_name = _shangjia_goodsId+'_'+_img_name;
                    let _img_src = 'https://down-my.img.susercontent.com/file/'+images[_imgkey];
                    downloadIamge(_img_src,_img_name);
                }
            }
        }
    }
}
//
function get_product_details_imgs(){
    let scriptdata = util_getscript_pageData_content($("html").html());
    if(scriptdata) {
        scriptdata = scriptdata.trim();
        let scriptdata_json = JSON.parse(scriptdata);
        console.log('scriptdata_json');
        console.log(scriptdata_json);
        //
        if(scriptdata_json && scriptdata_json['initialState']['item']['items']){
            //
            let items = scriptdata_json['initialState']['item']['items'];
            let items_keys_arr = Object.keys(items);
            let item_key = items_keys_arr[0];
            let _goods_data = items[item_key];
            if(_goods_data['status'] == 1){
                let _shangjia_goodsId = _goods_data['item_id'];
                if(_goods_data['rich_text_description']){
                    let _shangjia_productDetailFlatList_Data = _goods_data['rich_text_description']['paragraph_list'];
                    if(_shangjia_productDetailFlatList_Data){
                        for(_j=0;_j<_shangjia_productDetailFlatList_Data.length;_j++){
                            if(_shangjia_productDetailFlatList_Data[_j]['img_id']){
                                let _img_name = _shangjia_productDetailFlatList_Data[_j]['img_id'];
                                _img_name = _shangjia_goodsId+'_detail_'+_img_name;
                                let _img_src = 'https://down-my.img.susercontent.com/file/'+_shangjia_productDetailFlatList_Data[_j]['img_id'];
                                downloadIamge(_img_src,_img_name);
                            }
                        }
                    }
                }
            }
        }
    }
    //
}
//
function extract_products_lunbo_imgs(galleryimgs){
    console.log('extract_products_lunbo_imgs');
    console.log(galleryimgs);
    for(let i=0;i<galleryimgs.length;i++){
        downloadIamge(galleryimgs[i]['url'], galleryimgs[i]['name']);
    }
}

function extract_products_detail_imgs(detailsimgs){
    console.log('extract_products_detail_imgs');
    console.log(detailsimgs);
    for(let i=0;i<detailsimgs.length;i++){
        downloadIamge(detailsimgs[i]['url'], detailsimgs[i]['name']);
    }
}
//
function formatNumberForCSV(num) {
  // 使用 toFixed(15) 将数字转换为字符串，15 是足够大的小数位数，可以满足大多数情况
  let str = num.toFixed(15);

  // 移除尾部多余的零
  str = str.replace(/\.?0+$/, '');

  // 如果字符串中包含小数点，则不使用科学计数法
  if (str.indexOf('.') !== -1) {
    return str;
  }

  // 否则，返回字符串形式的整数
  return parseInt(str, 10).toString();
}

function exportToCsv(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".csv");
}

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

function export_shopify_csv_output(need_item){
    let export_datas = [];
    //
    if (true) {
        let shangjia_about_contact_and_basic_info = need_item;
        let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
        //
        let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
        //
        let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

        let futu1 = '';
        let futu2 = '';
        let futu3 = '';
        let futu4 = '';
        let futu5 = '';

        let futu6 = '';
        let futu7 = '';
        let futu8 = '';
        let futu9 = '';
        let futu10 = '';

        let futu11 = '';
        let futu12 = '';
        let futu13 = '';
        let futu14 = '';
        let futu15 = '';

        let futu16 = '';
        let futu17 = '';
        let futu18 = '';
        let futu19 = '';
        let futu20 = '';

        if(_shangjia_gallery_arr.length>=1){
            futu1 = _shangjia_gallery_arr[0];
        }
        if(_shangjia_gallery_arr.length>=2){
            futu2 = _shangjia_gallery_arr[1];
        }
        if(_shangjia_gallery_arr.length>=3){
            futu3 = _shangjia_gallery_arr[2];
        }
        if(_shangjia_gallery_arr.length>=4){
            futu4 = _shangjia_gallery_arr[3];
        }
        if(_shangjia_gallery_arr.length>=5){
            futu5 = _shangjia_gallery_arr[4];
        }
        if(_shangjia_gallery_arr.length>=6){
            futu6 = _shangjia_gallery_arr[5];
        }
        if(_shangjia_gallery_arr.length>=7){
            futu7 = _shangjia_gallery_arr[6];
        }
        if(_shangjia_gallery_arr.length>=8){
            futu8 = _shangjia_gallery_arr[7];
        }
        if(_shangjia_gallery_arr.length>=9){
            futu9 = _shangjia_gallery_arr[8];
        }
        if(_shangjia_gallery_arr.length>=10){
            futu10 = _shangjia_gallery_arr[9];
        }
        if(_shangjia_gallery_arr.length>=11){
            futu11 = _shangjia_gallery_arr[10];
        }
        if(_shangjia_gallery_arr.length>=12){
            futu12 = _shangjia_gallery_arr[11];
        }
        if(_shangjia_gallery_arr.length>=13){
            futu13 = _shangjia_gallery_arr[12];
        }
        if(_shangjia_gallery_arr.length>=14){
            futu14 = _shangjia_gallery_arr[13];
        }
        if(_shangjia_gallery_arr.length>=15){
            futu15 = _shangjia_gallery_arr[14];
        }
        if(_shangjia_gallery_arr.length>=16){
            futu16 = _shangjia_gallery_arr[15];
        }
        if(_shangjia_gallery_arr.length>=17){
            futu17 = _shangjia_gallery_arr[16];
        }
        if(_shangjia_gallery_arr.length>=18){
            futu18 = _shangjia_gallery_arr[17];
        }
        if(_shangjia_gallery_arr.length>=19){
            futu19 = _shangjia_gallery_arr[18];
        }
        if(_shangjia_gallery_arr.length>=20){
            futu20 = _shangjia_gallery_arr[19];
        }
        //
        let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
        //
        let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
        //
        let _body_html = '<div class="product-attr-wrapper">'+shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
        _body_html += '<div class="product-detail-wrapper">'+shangjia_about_contact_and_basic_info['_shangjia_product_desc']+'</div>';
        let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
        if(_shangjia_productDetailFlatList.length > 0){
            let _shangjia_productDetailFlatList_html = '<div class="product-detail-imgs-wrapper">';
            for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
                _shangjia_productDetailFlatList_html += "<div style='margin-bottom:5px'><img src='"+_shangjia_productDetailFlatList[_f]+"' /></div>";
            }
            _shangjia_productDetailFlatList_html +='</div>';
            _body_html += "<br />"+_shangjia_productDetailFlatList_html;
        }
        //
        let good_url = window.location.href;
        good_url = good_url.trim();
        if(good_url.indexOf('?')!=-1){
            let good_url_arr = good_url.split('?');
            good_url = good_url_arr[0];
        }
        //
        let handle_url = good_url.replace('https://','');
        let handle_url_arr = handle_url.split('/');
        let handle = handle_url_arr[1];
        handle = handle.replace('/','');
        //
        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let imgsrc = '';
            if(i==0){
                imgsrc = futu1;
            }else if(i==1){
                imgsrc = futu2;
            }else if(i==2){
                imgsrc = futu3;
            }else if(i==3){
                imgsrc = futu4;
            }else if(i==4){
                imgsrc = futu5;
            }else if(i==5){
                imgsrc = futu6;
            }else if(i==6){
                imgsrc = futu7;
            }else if(i==7){
                imgsrc = futu8;
            }else if(i==8){
                imgsrc = futu9;
            }else if(i==9){
                imgsrc = futu10;
            }else if(i==10){
                imgsrc = futu11;
            }else if(i==11){
                imgsrc = futu12;
            }else if(i==12){
                imgsrc = futu13;
            }else if(i==13){
                imgsrc = futu14;
            }else if(i==14){
                imgsrc = futu15;
            }else if(i==15){
                imgsrc = futu16;
            }else if(i==16){
                imgsrc = futu17;
            }else if(i==17){
                imgsrc = futu18;
            }else if(i==18){
                imgsrc = futu19;
            }else if(i==19){
                imgsrc = futu20;
            }
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            let _skuId = _shangjia_variants_skus[i]['skuId'];
            //
            let normalLinePriceStr = _shangjia_variants_skus[i]['normalLinePriceStr'];
            //
            let export_data_item = {
                'Handle': handle,
                'Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Body (HTML)': i==0?_body_html:'',
                'Vendor': i==0?'mysite':'',
                'Type':'',
                'Tags':'',
                'Published':i==0?'TRUE':'',
                'Option1 Name': specs_key1_name,
                'Option1 Value': _shangjia_variants_skus[i]['specs_key1_value'],
                'Option2 Name': specs_key2_name,
                'Option2 Value': _shangjia_variants_skus[i]['specs_key2_value'],
                'Option3 Name': specs_key3_name,
                'Option3 Value': _shangjia_variants_skus[i]['specs_key3_value'],
                'Variant SKU': _skuId,
                'Variant Grams': 0,
                'Variant Inventory Tracker':'shopify',
                'Variant Inventory Qty': _shangjia_variants_skus[i]['stockQuantity'],
                'Variant Inventory Policy':'continue',
                'Variant Fulfillment Service':'manual',
                'Variant Price':_shangjia_variants_skus[i]['normalPriceStr'],
                'Variant Compare At Price':normalLinePriceStr,
                'Variant Requires Shipping':'TRUE',
                'Variant Taxable':'TRUE',
                'Variant Barcode':'',
                'Image Src': imgsrc,
                'Image Position': imgsrc?(i+1):'',
                'Image Alt Text':'',
                'Gift Card': i==0?'FALSE':'',
                'SEO Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'SEO Description': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Google Shopping / Google Product Category':'',
                'Google Shopping / Gender':'',
                'Google Shopping / Age Group':'',
                'Google Shopping / MPN':'',
                'Google Shopping / AdWords Grouping':'',
                'Google Shopping / AdWords Labels':'',
                'Google Shopping / Condition':'',
                'Google Shopping / Custom Product':'',
                'Google Shopping / Custom Label 0':'',
                'Google Shopping / Custom Label 1':'',
                'Google Shopping / Custom Label 2':'',
                'Google Shopping / Custom Label 3':'',
                'Google Shopping / Custom Label 4':'',
                'Variant Image': _shangjia_variants_skus[i]['img'],
                'Variant Weight Unit':'',
                'Variant Tax Code':'',
                'Cost per item':'',
                'Status':i==0?'active':''
            }
            export_datas.push(export_data_item);
            //
        }
        //
        if(_shangjia_gallery_arr.length > _shangjia_variants_skus.length){
            //
            for(let _g=_shangjia_variants_skus.length;_g<_shangjia_gallery_arr.length;_g++){
                let export_data_item = {
                    'Handle': handle,
                    'Title': '',
                    'Body (HTML)': '',
                    'Vendor': '',
                    'Type':'',
                    'Tags':'',
                    'Published':'',
                    'Option1 Name': '',
                    'Option1 Value': '',
                    'Option2 Name': '',
                    'Option2 Value': '',
                    'Option3 Name': '',
                    'Option3 Value': '',
                    'Variant SKU': '',
                    'Variant Grams': '',
                    'Variant Inventory Tracker':'',
                    'Variant Inventory Qty': '',
                    'Variant Inventory Policy':'',
                    'Variant Fulfillment Service':'',
                    'Variant Price':'',
                    'Variant Compare At Price':'',
                    'Variant Requires Shipping':'',
                    'Variant Taxable':'',
                    'Variant Barcode':'',
                    'Image Src': _shangjia_gallery_arr[_g],
                    'Image Position': (_g+1),
                    'Image Alt Text':'',
                    'Gift Card': '',
                    'SEO Title': '',
                    'SEO Description': '',
                    'Google Shopping / Google Product Category':'',
                    'Google Shopping / Gender':'',
                    'Google Shopping / Age Group':'',
                    'Google Shopping / MPN':'',
                    'Google Shopping / AdWords Grouping':'',
                    'Google Shopping / AdWords Labels':'',
                    'Google Shopping / Condition':'',
                    'Google Shopping / Custom Product':'',
                    'Google Shopping / Custom Label 0':'',
                    'Google Shopping / Custom Label 1':'',
                    'Google Shopping / Custom Label 2':'',
                    'Google Shopping / Custom Label 3':'',
                    'Google Shopping / Custom Label 4':'',
                    'Variant Image': '',
                    'Variant Weight Unit':'',
                    'Variant Tax Code':'',
                    'Cost per item':'',
                    'Status':''
                }
                export_datas.push(export_data_item);
            }
        }
        exportToCsv(export_datas, 'gycharm-shopee-shopify-export-'+_shangjia_goodsId, "Sheet1");
    }
}

function export_tiktok_xlsx_output(need_item){
    let export_datas = [];
    let shangjia_about_contact_and_basic_info = need_item;
    let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
    //
    let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
    //
    let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

    let futu1 = '';
    let futu2 = '';
    let futu3 = '';
    let futu4 = '';
    let futu5 = '';

    let futu6 = '';
    let futu7 = '';
    let futu8 = '';
    let futu9 = '';
    let futu10 = '';

    let futu11 = '';
    let futu12 = '';
    let futu13 = '';
    let futu14 = '';
    let futu15 = '';

    let futu16 = '';
    let futu17 = '';
    let futu18 = '';
    let futu19 = '';
    let futu20 = '';

    if(_shangjia_gallery_arr.length>=1){
        futu1 = _shangjia_gallery_arr[0];
    }
    if(_shangjia_gallery_arr.length>=2){
        futu2 = _shangjia_gallery_arr[1];
    }
    if(_shangjia_gallery_arr.length>=3){
        futu3 = _shangjia_gallery_arr[2];
    }
    if(_shangjia_gallery_arr.length>=4){
        futu4 = _shangjia_gallery_arr[3];
    }
    if(_shangjia_gallery_arr.length>=5){
        futu5 = _shangjia_gallery_arr[4];
    }
    if(_shangjia_gallery_arr.length>=6){
        futu6 = _shangjia_gallery_arr[5];
    }
    if(_shangjia_gallery_arr.length>=7){
        futu7 = _shangjia_gallery_arr[6];
    }
    if(_shangjia_gallery_arr.length>=8){
        futu8 = _shangjia_gallery_arr[7];
    }
    if(_shangjia_gallery_arr.length>=9){
        futu9 = _shangjia_gallery_arr[8];
    }
    if(_shangjia_gallery_arr.length>=10){
        futu10 = _shangjia_gallery_arr[9];
    }
    if(_shangjia_gallery_arr.length>=11){
        futu11 = _shangjia_gallery_arr[10];
    }
    if(_shangjia_gallery_arr.length>=12){
        futu12 = _shangjia_gallery_arr[11];
    }
    if(_shangjia_gallery_arr.length>=13){
        futu13 = _shangjia_gallery_arr[12];
    }
    if(_shangjia_gallery_arr.length>=14){
        futu14 = _shangjia_gallery_arr[13];
    }
    if(_shangjia_gallery_arr.length>=15){
        futu15 = _shangjia_gallery_arr[14];
    }
    if(_shangjia_gallery_arr.length>=16){
        futu16 = _shangjia_gallery_arr[15];
    }
    if(_shangjia_gallery_arr.length>=17){
        futu17 = _shangjia_gallery_arr[16];
    }
    if(_shangjia_gallery_arr.length>=18){
        futu18 = _shangjia_gallery_arr[17];
    }
    if(_shangjia_gallery_arr.length>=19){
        futu19 = _shangjia_gallery_arr[18];
    }
    if(_shangjia_gallery_arr.length>=20){
        futu20 = _shangjia_gallery_arr[19];
    }
    //
    let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
    //
    let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
    //
    //
    let _body_html = '<div class="product-attr-wrapper">'+shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
    _body_html += '<div class="product-detail-wrapper">'+shangjia_about_contact_and_basic_info['_shangjia_product_desc']+'</div>';
    let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
    if(_shangjia_productDetailFlatList.length > 0){
        let _shangjia_productDetailFlatList_html = '<div class="product-detail-imgs-wrapper">';
        for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
            _shangjia_productDetailFlatList_html += "<div style='margin-bottom:5px'><img src='"+_shangjia_productDetailFlatList[_f]+"' /></div>";
        }
        _shangjia_productDetailFlatList_html +='</div>';
        _body_html += "<br />"+_shangjia_productDetailFlatList_html;
    }
    //
    for(let i=0;i<_shangjia_variants_skus.length;i++){
        //
        let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
        let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
        let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
        let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
        //
        let _skuId = _shangjia_variants_skus[i]['skuId'];
        _skuId = 'T'+_skuId;
        //
        let _category = shangjia_about_contact_and_basic_info['_shangjia_category'];
        let _category_str = '';
        let _category_arr = _category.split('>');
        if(_category_arr.length>=2){
            _category_str = _category_arr[1];
        }else{
            _category_str = _category_arr[0];
        }
        _category_str = _category_str.trim();

        let export_data_item = {
            'Category': _category_str,
            'Brand':'',
            'Product Name': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
            'Product Description': _body_html,
            'Package Weight(lb)':'',
            'Package Length(inch)':'',
            'Package Width(inch)':'',
            'Package Height(inch)':'',
            'Delivery options':'Default',
            'Identifier Code Type':'',
            'Identifier Code':'',
            '属性1名': specs_key1_name,
            'Variation 1': _shangjia_variants_skus[i]['specs_key1_value'],
            '属性2名': specs_key2_name,
            'Variation 2': _shangjia_variants_skus[i]['specs_key2_value'],
            '属性3名': specs_key3_name,
            'Variation 3': _shangjia_variants_skus[i]['specs_key3_value'],
            '属性4名': specs_key4_name,
            'Variation 4': _shangjia_variants_skus[i]['specs_key4_value'],
            'Variant Image': _shangjia_variants_skus[i]['img'],
            'Retail Price (Local Currency)': _shangjia_variants_skus[i]['normalPriceStr'],
            'Quantity in RUIZ SPORT STORE': _shangjia_variants_skus[i]['stockQuantity'],
            'Seller SKU': _skuId,
            'Main Product Image': _shangjia_variants_skus[i]['img'],
            'Product Image 2': futu1,
            'Product Image 3': futu2,
            'Product Image 4': futu3,
            'Product Image 5': futu4,
            'Product Image 6': futu5,
            'Product Image 7': futu6,
            'Product Image 8': futu7,
            'Product Image 9': futu8,
            'Product Image 10': futu9,
            'Product Image 11': futu10,
            'Product Image 12': futu11,
            'Product Image 13': futu12,
            'Product Image 14': futu13,
            'Product Image 15': futu14,
            'Product Image 16': futu15,
            'Product Image 17': futu16,
            'Product Image 18': futu17,
            'Product Image 19': futu18,
            'Product Image 20': futu19,
            'Product Image 21': futu20,
            'Size Chart':'',
            'Product Status':'',
        }
        export_datas.push(export_data_item);
        //
    }
    //
    exportToExcel(export_datas, 'gycharm-shopee-tiktok-export-'+Date.now(), "Sheet1");
    //
}

function export_normail_xlsx_output(need_item){
    console.log('export_normail_xlsx_output');
    let export_datas = [];
    let shangjia_about_contact_and_basic_info = need_item;
    //
    let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
    //
    let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

    let futu1 = '';
    let futu2 = '';
    let futu3 = '';
    let futu4 = '';
    let futu5 = '';

    let futu6 = '';
    let futu7 = '';
    let futu8 = '';
    let futu9 = '';
    let futu10 = '';

    let futu11 = '';
    let futu12 = '';
    let futu13 = '';
    let futu14 = '';
    let futu15 = '';

    let futu16 = '';
    let futu17 = '';
    let futu18 = '';
    let futu19 = '';
    let futu20 = '';

    if(_shangjia_gallery_arr.length>=1){
        futu1 = _shangjia_gallery_arr[0];
    }
    if(_shangjia_gallery_arr.length>=2){
        futu2 = _shangjia_gallery_arr[1];
    }
    if(_shangjia_gallery_arr.length>=3){
        futu3 = _shangjia_gallery_arr[2];
    }
    if(_shangjia_gallery_arr.length>=4){
        futu4 = _shangjia_gallery_arr[3];
    }
    if(_shangjia_gallery_arr.length>=5){
        futu5 = _shangjia_gallery_arr[4];
    }
    if(_shangjia_gallery_arr.length>=6){
        futu6 = _shangjia_gallery_arr[5];
    }
    if(_shangjia_gallery_arr.length>=7){
        futu7 = _shangjia_gallery_arr[6];
    }
    if(_shangjia_gallery_arr.length>=8){
        futu8 = _shangjia_gallery_arr[7];
    }
    if(_shangjia_gallery_arr.length>=9){
        futu9 = _shangjia_gallery_arr[8];
    }
    if(_shangjia_gallery_arr.length>=10){
        futu10 = _shangjia_gallery_arr[9];
    }
    if(_shangjia_gallery_arr.length>=11){
        futu11 = _shangjia_gallery_arr[10];
    }
    if(_shangjia_gallery_arr.length>=12){
        futu12 = _shangjia_gallery_arr[11];
    }
    if(_shangjia_gallery_arr.length>=13){
        futu13 = _shangjia_gallery_arr[12];
    }
    if(_shangjia_gallery_arr.length>=14){
        futu14 = _shangjia_gallery_arr[13];
    }
    if(_shangjia_gallery_arr.length>=15){
        futu15 = _shangjia_gallery_arr[14];
    }
    if(_shangjia_gallery_arr.length>=16){
        futu16 = _shangjia_gallery_arr[15];
    }
    if(_shangjia_gallery_arr.length>=17){
        futu17 = _shangjia_gallery_arr[16];
    }
    if(_shangjia_gallery_arr.length>=18){
        futu18 = _shangjia_gallery_arr[17];
    }
    if(_shangjia_gallery_arr.length>=19){
        futu19 = _shangjia_gallery_arr[18];
    }
    if(_shangjia_gallery_arr.length>=20){
        futu20 = _shangjia_gallery_arr[19];
    }
    //
    let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
    //
    let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
    //
    let good_url = window.location.href;
    good_url = good_url.trim();
    if(good_url.indexOf('?')!=-1){
        let good_url_arr = good_url.split('?');
        good_url = good_url_arr[0];
    }
    //
    let _body_html = '<div class="product-attr-wrapper">'+shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
    _body_html += '<div class="product-detail-wrapper">'+shangjia_about_contact_and_basic_info['_shangjia_product_desc']+'</div>';
    let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
    if(_shangjia_productDetailFlatList.length > 0){
        let _shangjia_productDetailFlatList_html = '<div class="product-detail-imgs-wrapper">';
        for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
            _shangjia_productDetailFlatList_html += "<div style='margin-bottom:5px'><img src='"+_shangjia_productDetailFlatList[_f]+"' /></div>";
        }
        _shangjia_productDetailFlatList_html +='</div>';
        _body_html += "<br />"+_shangjia_productDetailFlatList_html;
    }
    //
    for(let i=0;i<_shangjia_variants_skus.length;i++){
        //
        let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
        let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
        let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
        let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
        //
        let normalLinePriceStr = '';
        if(_shangjia_variants_skus[i].hasOwnProperty('normalLinePriceStr')){
            normalLinePriceStr = _shangjia_variants_skus[i]['normalLinePriceStr'];
        }
        let export_data_item = {
            '产品url': good_url,
            'SKU': shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
            '原变体SKU': _shangjia_variants_skus[i]['skuId'],
            '变体带属性SKU': _shangjia_variants_skus[i]['subsku'],
            '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
            'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
            '变体图片': _shangjia_variants_skus[i]['img'],
            '价格': _shangjia_variants_skus[i]['normalPriceStr'],
            '原价': normalLinePriceStr,
            '变体库存': _shangjia_variants_skus[i]['stockQuantity'],
            '属性1名': specs_key1_name,
            '属性1值': _shangjia_variants_skus[i]['specs_key1_value'],
            '属性2名': specs_key2_name,
            '属性2值': _shangjia_variants_skus[i]['specs_key2_value'],
            '属性3名': specs_key3_name,
            '属性3值': _shangjia_variants_skus[i]['specs_key3_value'],
            '属性4名': specs_key4_name,
            '属性4值': _shangjia_variants_skus[i]['specs_key4_value'],
            '主图': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
            '附图1': futu1,
            '附图2': futu2,
            '附图3': futu3,
            '附图4': futu4,
            '附图5': futu5,
            '附图6': futu6,
            '附图7': futu7,
            '附图8': futu8,
            '附图9': futu9,
            '附图10': futu10,
            '附图11': futu11,
            '附图12': futu12,
            '附图13': futu13,
            '附图14': futu14,
            '附图15': futu15,
            '附图16': futu16,
            '附图17': futu17,
            '附图18': futu18,
            '附图19': futu19,
            '附图20': futu20,
            'VideoUrl': shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'],
            '产品描述': _body_html,
            '描述图片': shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'].join(','),
            //review
            'review': shangjia_about_contact_and_basic_info['_shangjia_reivew_num'],
            'sold': _shangjia_sold,
            'liked': shangjia_about_contact_and_basic_info['_shangjia_liked_count'],
            //store
            'store name': shangjia_about_contact_and_basic_info['_shangjia_store_name'],
            'store url': shangjia_about_contact_and_basic_info['_shangjia_store_url'],
            'store sold': shangjia_about_contact_and_basic_info['_shangjia_store_sold'],
            'store review': shangjia_about_contact_and_basic_info['_shangjia_store_review_num'],
            'store score': shangjia_about_contact_and_basic_info['_shangjia_store_score'],
            'store followers': shangjia_about_contact_and_basic_info['_shangjia_store_followers'],
            'store items': _shangjia_store_items,
            'store country': shangjia_about_contact_and_basic_info['_shangjia_store_country'],
            'store join date': shangjia_about_contact_and_basic_info['_shangjia_store_created_at']
             //
             //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
        }
        export_datas.push(export_data_item);
       //
    }
     //
    exportToExcel(export_datas, 'gycharm-shopee-normail-export-'+Date.now(), "Sheet1");
    //
}

function export_single(pingtai='shopify') {
    //
    let scriptdata = util_getscript_pageData_content($("html").html());
    if (scriptdata) {
        scriptdata = scriptdata.trim();
        let scriptdata_json = JSON.parse(scriptdata);
        console.log('scriptdata_json');
        console.log(scriptdata_json);
        //
        if(scriptdata_json && scriptdata_json['initialState']['item']['items']){
            let current_shopee_url = util_get_shopee_main_website();
            let need_item = {
                '_shangjia_id': '',
                '_shangjia_about_contact_and_basic_info_link': '',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_items': '',
                '_shangjia_store_followers': '',
                '_shangjia_store_sold': '',
                '_shangjia_store_score': '',
                '_shangjia_store_review_num':'',
                '_shangjia_store_created_at':'',
                '_shangjia_store_country':'',
                //
                '_shangjia_goodsId': '', //sku
                '_shangjia_variants_skus': [], //数组
                '_shangjia_goodsName': '',
                '_shangjia_goodsProperty': '',//description,deschtml
                '_shangjia_minOnSalePriceStr': '', //最小价格,当没有属性时选择该价格
                '_shangjia_hdThumbUrl': '',//主图
                '_shangjia_gallery': [], //图片列表
                '_shangjia_productDetailFlatList': [],//details imgs
                '_shangjia_category': '',//brumb
                '_shangjia_VideoUrl': '', //video
                '_shangjia_liked_count':'',
                '_shangjia_sold':'',
                '_shangjia_reivew_num':'',
                '_shangjia_product_desc':'',
                '_shangjia_brand':''
            };

            let items = scriptdata_json['initialState']['item']['items'];
            let items_keys_arr = Object.keys(items);
            let item_key = items_keys_arr[0];
            let _goods_data = items[item_key];

            if (_goods_data['status'] == 1) {

                let _shangjia_goodsId = _goods_data['item_id'];
                need_item['_shangjia_goodsId'] = 'S'+_shangjia_goodsId;

                let _shangjia_goodsName = _goods_data['name'];
                need_item['_shangjia_goodsName'] = _shangjia_goodsName;

                if(_goods_data.hasOwnProperty('brand')){
                    need_item['_shangjia_brand'] = _goods_data['brand'];
                }

                need_item['_shangjia_hdThumbUrl'] = 'https://down-my.img.susercontent.com/file/'+_goods_data['image'];

                let _shangjia_minOnSalePriceStr = util_price_format(_goods_data['price']);
                need_item['_shangjia_minOnSalePriceStr'] = _shangjia_minOnSalePriceStr;

                let _shangjia_gallery = [];
                let _shangjia_VideoUrl = '';
                let images = _goods_data['images'];
                for(let _imgkey=0;_imgkey < images.length; _imgkey++){
                    _shangjia_gallery.push('https://down-my.img.susercontent.com/file/'+images[_imgkey])
                }
                need_item['_shangjia_gallery'] = _shangjia_gallery;

                if(_goods_data.hasOwnProperty('video_info_list')){
                    let video_info_list = _goods_data['video_info_list'];
                    if(video_info_list.length > 0){
                        if(video_info_list[0]['default_format']){
                            _shangjia_VideoUrl = video_info_list[0]['default_format']['url'];
                            need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                        }
                    }
                }
                //
                if(_goods_data.hasOwnProperty('attributes')){
                    let _shangjia_goodsProperty_list = _goods_data['attributes'];
                    if(_shangjia_goodsProperty_list){
                        let _shangjia_goodsProperty ='<ul>';
                        for(let _f=0;_f<_shangjia_goodsProperty_list.length;_f++){
                            let _attr_name = _shangjia_goodsProperty_list[_f]['name'];
                            let _attr_value = _shangjia_goodsProperty_list[_f]['value'];
                            _shangjia_goodsProperty += '<li>'+_attr_name+
                                ':&nbsp;&nbsp;'+_attr_value + '</li>';

                        }
                        _shangjia_goodsProperty +='</ul>';
                        need_item['_shangjia_goodsProperty'] = _shangjia_goodsProperty;
                    }
                }
                //
                need_item['_shangjia_product_desc'] = _goods_data['description'];
                //
                let _shangjia_productDetailFlatList = [];
                if(_goods_data['rich_text_description']){
                    let _shangjia_productDetailFlatList_Data = _goods_data['rich_text_description']['paragraph_list'];
                    if(_shangjia_productDetailFlatList_Data){
                        for(_j=0;_j<_shangjia_productDetailFlatList_Data.length;_j++){
                            if(_shangjia_productDetailFlatList_Data[_j]['img_id']){
                                _shangjia_productDetailFlatList.push("https://down-my.img.susercontent.com/file/"+_shangjia_productDetailFlatList_Data[_j]['img_id']);
                            }
                        }
                    }
                    need_item['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                }
                //
                let _shangjia_category = '';
                let fe_categories = _goods_data['fe_categories'];
                for(let fc=0;fc<fe_categories.length;fc++){
                    _shangjia_category += fe_categories[fc]['display_name']+' > ';
                }
                if(_shangjia_category){
                    _shangjia_category = _shangjia_category.trim();
                    _shangjia_category = _shangjia_category.slice(0,-1);
                    need_item['_shangjia_category'] = _shangjia_category;
                }
                //
                let tier_variations = _goods_data['tier_variations'];
                let props = [];
                for(let tv=0;tv<tier_variations.length;tv++){
                    props.push(util_capitalizeFirstLetter(tier_variations[tv]['name']));
                }
                //属性组合排序
                let propall = [];
                if(tier_variations.length == 1){
                    propall = tier_variations[0]['options'];
                }else if(tier_variations.length == 2){
                    let pro1_arr = tier_variations[0]['options'];
                    let pro2_arr = tier_variations[1]['options'];
                    for(let pro1i=0;pro1i<pro1_arr.length;pro1i++){
                        let _prop = pro1_arr[pro1i];
                        for(let pro2i=0;pro2i<pro2_arr.length;pro2i++){
                            propall.push(_prop+','+pro2_arr[pro2i]);
                        }
                    }
                }
                //
                console.log('propall');
                console.log(propall);
                //
                let _shangjia_variants_skus = [];
                let _skus = _goods_data['models'];
                if(_skus && _skus.length > 0){
                                   for(let _i=0;_i<_skus.length;_i++){
                                       let specs_key1_name = '';
                                       let specs_key1_value = '';

                                       let specs_key2_name = '';
                                       let specs_key2_value = '';

                                       let specs_key3_name = '';
                                       let specs_key3_value = '';

                                       let specs_key4_name = '';
                                       let specs_key4_value = '';

                                       let _prop_name = _skus[_i]['name'];
                                       let _prop_name_arr = _prop_name.split(',');
                                       if(_prop_name_arr.length == 1){
                                            specs_key1_name = props[0];
                                            specs_key1_value = _prop_name_arr[0];
                                       }else if(_prop_name_arr.length == 2){
                                            specs_key1_name = props[0];
                                            specs_key1_value = _prop_name_arr[0];

                                            specs_key2_name = props[1];
                                            specs_key2_value = _prop_name_arr[1];
                                       }else if(_prop_name_arr.length == 3){
                                            specs_key1_name = props[0];
                                            specs_key1_value = _prop_name_arr[0];

                                            specs_key2_name = props[1];
                                            specs_key2_value = _prop_name_arr[1];

                                            specs_key3_name = props[2];
                                            specs_key3_value = _prop_name_arr[2];
                                       }else if(_prop_name_arr.length == 4){
                                            specs_key1_name = props[0];
                                            specs_key1_value = _prop_name_arr[0];

                                            specs_key2_name = props[1];
                                            specs_key2_value = _prop_name_arr[1];

                                            specs_key3_name = props[2];
                                            specs_key3_value = _prop_name_arr[2];

                                            specs_key4_name = props[3];
                                            specs_key4_value = _prop_name_arr[3];
                                       }
                                       let subsku_specs = _prop_name.replaceAll(',','-');
                                       //
                                       let _subimg = '';
                                       if(specs_key1_value){
                                           if(tier_variations.length>0){
                                               if(tier_variations[0]['images']){
                                                   let _tvoptions = tier_variations[0]['options'];
                                                   for(let _tvi=0;_tvi<_tvoptions.length;_tvi++){
                                                   if(specs_key1_value == _tvoptions[_tvi]){
                                                       _subimg = 'https://down-my.img.susercontent.com/file/'+tier_variations[0]['images'][_tvi];
                                                       break;
                                                   }
                                                }
                                               }
                                           }
                                       }
                                       //
                                       let sort = 0;
                                       for(let pi=0;pi<propall.length;pi++){
                                           if(_prop_name == propall[pi]){
                                               sort = pi+1;
                                               break;
                                           }
                                       }
                                       //
                                       _shangjia_variants_skus.push({
                                            'subsku': _skus[_i]['modelid']+subsku_specs,
                                            'normalPriceStr': util_price_format(_skus[_i]['price']),
                                            'normalLinePriceStr': util_price_format(_skus[_i]['price_before_discount']),
                                            'img':_subimg,
                                            'specs_key1_name':specs_key1_name,
                                            'specs_key1_value':specs_key1_value,
                                            'specs_key2_name':specs_key2_name,
                                            'specs_key2_value':specs_key2_value,
                                            'specs_key3_name':specs_key3_name,
                                            'specs_key3_value':specs_key3_value,
                                            'specs_key4_name':specs_key4_name,
                                            'specs_key4_value':specs_key4_value,
                                            'stockQuantity': _skus[_i]['stock'],
                                            'skuId':  'S'+_skus[_i]['modelid'],
                                            'sort': sort
                                       });
                                       //
                                   }
                               }
                //
                let _new_shangjia_variants_skus = util_dictArraySorting(_shangjia_variants_skus, 'sort', 'asc');
                //
                need_item['_shangjia_variants_skus'] = _new_shangjia_variants_skus;
                //'_shangjia_review_score': '',
                //'_shangjia_reivew_num':'',
                need_item['_shangjia_sold'] = _goods_data['global_sold'];
                //
                need_item['_shangjia_liked_count'] = _goods_data['liked_count'];
                //
                need_item['_shangjia_reivew_num'] = _goods_data['item_rating']['total_rating_count'];
                //

                //store
                let _store_key = scriptdata_json['initialState']['DOMAIN_PDP']['data']['PDP_BFF_DATA']['currentKey'];
                let _store_data = scriptdata_json['initialState']['DOMAIN_PDP']['data']['PDP_BFF_DATA']['cachedMap'][_store_key]['shop_detailed'];
                console.log('_store_data');
                console.log(_store_data);
                need_item['_shangjia_store_country'] = _goods_data['shop_location'];
                /**
                                * '_shangjia_store_name': '',
                                '_shangjia_store_url': '',
                                '_shangjia_store_items': '',
                                '_shangjia_store_followers': '',
                                '_shangjia_store_sold': '',
                                '_shangjia_store_score': '',
                 */
                let _shangjia_store_review_num = _store_data['rating_bad']+_store_data['rating_good']+_store_data['rating_normal'];
                need_item['_shangjia_store_review_num'] = _shangjia_store_review_num;

                need_item['_shangjia_store_name'] = _store_data['name'];
                need_item['_shangjia_store_url'] = current_shopee_url+'/'+_store_data['account']['username'];
                need_item['_shangjia_store_items'] = _store_data['item_count'];
                need_item['_shangjia_store_followers'] = _store_data['follower_count'];
                need_item['_shangjia_store_sold'] = _store_data['sold_total'];
                need_item['_shangjia_store_score'] = _store_data['rating_star'];
                let _shangjia_store_created_at = $('.page-product__shop .NGzCXN .YnZi6x:eq(2)').find('span').text();
                need_item['_shangjia_store_created_at'] = _shangjia_store_created_at;
                //
                console.log('need_item');
                console.log(need_item);

                //export csv
                if(pingtai == 'shopify'){
                    export_shopify_csv_output(need_item);
                }else if(pingtai == 'tiktok'){
                    export_tiktok_xlsx_output(need_item);
                }else if(pingtai == 'normal'){
                    export_normail_xlsx_output(need_item);
                }
                //
            }
        }
        //
    }
}

function productListUrlExport(){
    //
    console.log('productListUrlExport');
    let export_datas = [];
    $(".autoFitList:eq(0) ._3GizL2ou").each(function (){
        console.log('a1');
        let _shangjia_a_link = $(this).find('a').attr('href');
        if (_shangjia_a_link && _shangjia_a_link.indexOf('goods.html') == -1) {
            let _shangjia_a_link_www = 'https://www.temu.com' + _shangjia_a_link;
            console.log('_shangjia_a_link_www:'+_shangjia_a_link_www);
            export_datas.push({
                'product url': _shangjia_a_link_www
            });
        }
    });
    exportToExcel(export_datas, 'gycharm-product-list-url-export-'+Date.now(), "Sheet1");
    //
}

function productMaijiaListUrlExport(){
    //
    console.log('productMaijiaListUrlExport');
    let export_datas = [];
    $(".mainContent ._3wENoqiV .autoFitList ._3GizL2ou").each(function (){
        console.log('a1');
        let _shangjia_a_link = $(this).find('a').attr('href');
        if (_shangjia_a_link && _shangjia_a_link.indexOf('goods.html') == -1) {
            let _shangjia_a_link_www = 'https://www.temu.com' + _shangjia_a_link;
            console.log('_shangjia_a_link_www:'+_shangjia_a_link_www);
            export_datas.push({
                'product url': _shangjia_a_link_www
            });
        }
    });
    exportToExcel(export_datas, 'gycharm-product-list-url-export-'+Date.now(), "Sheet1");
    //
}
//
function add_export_pingtai_btn(){
    console.log('add_export_pingtai_btn');
    let current_url = window.location.href;
    // 创建一个按钮元素
    if(current_url.indexOf('-i')!=-1 || current_url.indexOf('/product/')!=-1){
        console.log('add_export_pingtai_btn a1');
         //
         var newNormalButton = $("<button>", {
            text: '通用Excel格式导出', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 795px;\n" +
                "    left:10px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
                export_single('normal');
            } // 点击按钮时执行的函数
         });
         $('section.TFDXyQ').append(newNormalButton);
         //

         var newButton = $("<button>", {
            text: '导出Shopify格式', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 848px;\n" +
                "    left: 10px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('shopify');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('section.TFDXyQ').append(newButton);
        //
        var newTiktokButton = $("<button>", {
            text: '导出Tiktok格式', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 900px;\n" +
                "    left: 10px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('tiktok');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('section.TFDXyQ').append(newTiktokButton);
        //

        var btn_product_lunbo_imgs = $("<button>", {
            text: '下载轮播图', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 950px;\n" +
                "    left: 10px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               get_product_lunbo_imgs();
            } // 点击按钮时执行的函数
        });
        $('section.TFDXyQ').append(btn_product_lunbo_imgs);
        //

        var btn_product_details_imgs = $("<button>", {
            text: '下载Details图片', // 按钮文本
            style: "display: block;\n" +
                "    position: absolute;\n" +
                "    top: 1000px;\n" +
                "    left: 10px;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    border: 0;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               get_product_details_imgs();
            } // 点击按钮时执行的函数
        });
        $('section.TFDXyQ').append(btn_product_details_imgs);
        //
    }
}
//
function add_productListUrlExportButton(){
    //
    let current_url = window.location.href;
    console.log('add_productListUrlExportButton aa11');

    $('button.productListUrlExportButton').remove();
     // 创建一个按钮元素
    if(current_url.indexOf('-m-')!=-1){
        var productListUrlExportButton = $("<button>", {
            text: '商品网址导出', // 按钮文本
            class:'productListUrlExportButton',
            style: "display: block;\n" +
                    "    position: absolute;z-index:9999;\n" +
                    "bottom:14px;left:115px;"+
                    "    background: #fb7701;\n" +
                    "    width: 160px;\n" +
                    "    height: 46px;\n" +
                    "    line-height: 46px;\n" +
                    "    color: #FFF;\n" +
                    "    font-weight: bold;\n" +
                    "    cursor:pointer;\n" +
                    "    border-radius: 22px;",
            click: function() {
                productMaijiaListUrlExport();
            } // 点击按钮时执行的函数
        });
        $('._25EQ1kor').append(productListUrlExportButton);
    }else{
        var productListUrlExportButton = $("<button>", {
            text: '商品网址导出', // 按钮文本
            class:'productListUrlExportButton',
            style: "display: block;\n" +
                    "    position: relative;\n" +
                    "    background: #fb7701;\n" +
                    "    width: 180px;\n" +
                    "    height: 46px;\n" +
                    "    line-height: 46px;\n" +
                    "    color: #FFF;\n" +
                    "    font-weight: bold;\n" +
                    "    cursor:pointer;\n" +
                    "    border-radius: 22px;",
            click: function() {
                productListUrlExport();
            } // 点击按钮时执行的函数
        });
        $('.autoFitList').append(productListUrlExportButton);
    }
}
//
function add_productListAddToPluginButton(){
    //
    let current_url = window.location.href;
    if (current_url.indexOf('search?keyword') != -1 || current_url.indexOf('-cat') != -1) {
        $('button.productListAddToPluginButton').remove();
        var productListAddToPluginButton = $("<button>", {
                text: '加入列表商品到采集插件', // 按钮文本
                class:'productListAddToPluginButton',
                style: "display: block;\n" +
                        "    position: relative;z-index:9999;\n" +
                        "    background: #fb7701;\n" +
                        "    width: 180px;\n" +
                        "    height: 46px;\n" +
                        "    line-height: 46px;\n" +
                        "    border: 0;\n" +
                        "    color: #FFF;\n" +
                        "    font-weight: bold;\n" +
                        "    cursor:pointer;\n" +
                        "    margin-top:-100px;\n" +
                        "    border-radius: 22px;",
                click: function() {
                    shangjia_search_caiji();
                    $('.productListAddToPluginButton').text('已加入');
                } // 点击按钮时执行的函数
            });
            $('.shopee-search-item-result').append(productListAddToPluginButton);
    }
}

$(document).ready(function () {
    setTimeout(function (){
        add_export_pingtai_btn();
        //add_productListUrlExportButton();
        //add_productListAddToPluginButton();
    },2000);
});

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract-product-lunbo-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_lunbo_imgs();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract-product-details-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_details_imgs();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_products_lunbo_imgs'){
        console.log(request.info);
        catalog_products_url = extract_products_lunbo_imgs(request.galleryimgs);
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_products_detail_imgs'){
        console.log(request.info);
        catalog_products_url = extract_products_detail_imgs(request.detailsimgs);
        sendResponse(catalog_products_url);
    }
})